<template>
  <ObModal
    ref="delete-warning"
    :is-error="true"
  >
    <div slot="title">
      <i :class="[ 'icon alert heading__icon', { 'with-error': errorMessage } ]" />

      <span class="heading__title ob-ty-modal-title">
        <template v-if="errorMessage">Удаление {{ isOrganization ? 'участника' : 'ресурса' }} невозможно</template>
        <template v-else>Удалить {{ isOrganization ? 'участника' : 'ресурс' }}?</template>
      </span>
    </div>

    <ObForm
      :form-data="formData"
      :is-error="!errorMessage"
      :is-submit-disabled="false"
      :is-read-only="!!errorMessage"
      :is-loading="isLoading"
      ok-text="Удалить"
      cancel-text="Оставить"
      @submit="onSubmit"
    >
      <div class="form-content">
        <i
          v-if="isOrganization"
          class="icon truck"
        />

        <slot />
      </div>

      <div
        v-if="errorMessage"
        class="error"
      >
        {{ errorMessage }}
      </div>
    </ObForm>
  </ObModal>
</template>

<script>
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObForm from 'common-components/src/obComponents/obForm'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'

  export default {
    name: "delete-organization",
    components: {
      ObModal,
      ObForm
    },
    mixins: [
      FormValidationMixin
    ],
    data () {
      return {
        isLoading: false
      }
    },
    props: {
      errorMessage: {
        type: String,
        default: null
      },
      isOrganization: {
        type: Boolean,
        default: true
      }
    },
    watch: {
      errorMessage () {
        this.isLoading = false
      }
    },
    methods: {
      open () {
        this.$refs['delete-warning'].open()
      },
      close () {
        this.$refs['delete-warning'].close()
      },
      onSubmit () {
        this.isLoading = true

        this.$emit('submit', this.formData)
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .heading {
    &__title {
      color: $color-error;
      line-height: 36px;
    }

    &__icon {
      position: relative;
      color: $color-error;
      font-size: 24px;
      margin-right: 18px;

      &.with-error {
        margin-right: 10px;
      }
    }
  }

  .form-content {
    @include font-mixin(16px, 20px, bold, $color-text-base, 0.4px);

    display: flex;
    align-items: center;

    &:not(:last-child) {
      margin-bottom: 30px;
    }

    .icon {
      font-size: 24px;
      font-weight: 700;
      margin-right: 11px;
      color: $color-blue-navy-blue;
    }
  }

  .error {
    @include font-mixin(16px, 20px, 400, $color-text-base, 0.4px);
  }
</style>